 ###############################################
#                                               #
#                Easy errorInfo                 #
#       v1.0 (30/05/2009)  par MenzAgitat       #
#                                               #
#          http://www.boulets-roxx.com          #
#        IRC:  irc.epiknet.org  #boulets        #
#              irc.teepi.net    #boulets        #
#                                               #
#     Mes scripts sont tlchargeables sur      #
#            http://www.egghelp.org             #
#        ou  http://www.eggdrop.fr              #
#                                               #
 ###############################################

#
# Description
#
# Easy errorInfo permet d'afficher le contenu de la variable systme $errorInfo
# en tapant .errorinfo en partyline ou sur un chan.
# Cela quivaut  taper .set errorInfo mais prsente l'avantage de ne pas
# ncessiter que la commande .set soit active et d'tre plus rapide  taper.
# Pour ceux qui ne connaissent pas la variable $errorInfo, elle contient la dernire
# erreur qu'a rencontr l'eggdrop, ainsi que son traceback.
# Avoir un rapport dtaill d'une erreur aide  la corriger plus facilement.

#
# Changelog
#
# 1.0 - 1re version
#

#
# LICENCE:
#		This program is free software; you can redistribute it and/or modify
#		it under the terms of the GNU General Public License as published by
#		the Free Software Foundation; either version 2 of the License, or
#		(at your option) any later version.
#
#		This program is distributed in the hope that it will be useful,
#		but WITHOUT ANY WARRANTY; without even the implied warranty of
#		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#		GNU General Public License for more details.
#

if { [lindex [split $version] 1] < 1061800 } { putloglev o * "\00304\002\[Easy errorInfo - ERREUR\]\002\003 La version de votre eggdrop est \00304\002[lindex [split $version] 0]\002\003; Easy_errorInfo.tcl ne fonctionnera correctement que sur les eggdrops version 1.6.18 ou suprieure." ; return }
if { $tcl_version < 8.4 } { putloglev o * "\00304\002\[Easy errorInfo - ERREUR\]\002\003 Easy_errorInfo.tcl ncessite que Tcl 8.4 (ou plus) soit install pour fonctionner. Votre version actuelle de Tcl est \00304\002$tcl_version\002\003." ; return }
package require Tcl 8.4
if {[info commands Easy_errorInfo::uninstall] eq "::Easy_errorInfo::uninstall"} { Easy_errorInfo::uninstall }
namespace eval Easy_errorInfo {


	###########################
	#				PARAMETRES        #
	###########################

	# Commande servant  afficher le traceback d'une erreur (devra tre tape prcde d'un ".")
	variable errorInfo_cmd "errorinfo"

	# Autorisations pour l'utilisation de la commande
	variable errorInfo_auth "n|n"



#############################################################################
#  NE MODIFIEZ RIEN APRES CE CADRE SI VOUS NE SAVEZ PAS CE QUE VOUS FAITES  #
#############################################################################
	variable scriptname "Easy errorInfo"
	variable version "1.0.20090530"
	bind PUB $errorInfo_auth .$errorInfo_cmd Easy_errorInfo::debuginfo
	bind DCC $errorInfo_auth $errorInfo_cmd Easy_errorInfo::debuginfoDCC
	bind EVNT - prerehash Easy_errorInfo::uninstall
	proc uninstall {args} {
		putlog "Dsallocation des ressources de \002$Easy_errorInfo::scriptname...\002"
		foreach binding [lsearch -inline -all -regexp [binds *[set ns [string range [namespace current] 2 end]]*] " (::)?$ns"] {
			unbind [lindex $binding 0] [lindex $binding 1] [lindex $binding 2] [lindex $binding 4]
		}
		namespace delete ::Easy_errorInfo
	}
}

proc Easy_errorInfo::debuginfo {nick host hand chan arg} {
	set errorInfo_display [split $::errorInfo "\n"]
	foreach line $errorInfo_display {
		putquick "PRIVMSG $chan :\00314$line\003"
	}
	putquick "PRIVMSG $chan :\00314errorCode : $::errorCode\003"
}

proc Easy_errorInfo::debuginfoDCC {hand idx args} {
	putlog "\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-"
	putlog "$::errorInfo"
	putlog "\00314errorCode : $::errorCode\003"
	putlog "\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-\00305-\00304-"
}


putlog "\002*$Easy_errorInfo::scriptname v$Easy_errorInfo::version*\002 par MenzAgitat a t charg."
